package mobile;

import oracle.adfmf.java.beans.PropertyChangeListener;
import oracle.adfmf.java.beans.PropertyChangeSupport;

// Defines data structure for the return of the data from the local db and web service
// Supports updating records when their value changes with propertyChangeSupport (during Generate Accessors)

public class CountryBO implements Comparable{

private String id;
private String country;
private Integer regionId;
private transient PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);


public CountryBO() {
super();
}

public boolean equals(Object object) {
if (this == object) {
return true;
}
if (!(object instanceof CountryBO)) {
return false;
}
final CountryBO other = (CountryBO)object;
if (!(id == null ? other.id == null : id.equals(other.id))) {
return false;
}
return true;
}

public int hashCode() {
final int PRIME = 37;
int result = 1;
result = PRIME * result + ((id == null) ? 0 : id.hashCode());
return result;
}

public int compareTo(Object o) {
if (this.equals(o)){
return 0;
}
else if (o instanceof CountryBO){
return this.country.compareTo(((CountryBO)o).getCountry());
}
else{
throw new ClassCastException("CountryBO expected.");
}
}

public void setId(String countryId) {
String oldCountryId = this.id;
this.id = countryId;
propertyChangeSupport.firePropertyChange("countryId", oldCountryId, countryId);
}

public void addPropertyChangeListener(PropertyChangeListener l) {
propertyChangeSupport.addPropertyChangeListener(l);
}

public void removePropertyChangeListener(PropertyChangeListener l) {
propertyChangeSupport.removePropertyChangeListener(l);
}

public String getId() {
return id;
}

public void setCountry(String countryName) {
String oldCountryName = this.country;
this.country = countryName;
propertyChangeSupport.firePropertyChange("countryName", oldCountryName, countryName);
}

public String getCountry() {
return country;
}

public void setRegionId(Integer regionId) {
Integer oldRegionId = this.regionId;
this.regionId = regionId;
propertyChangeSupport.firePropertyChange("regionId", oldRegionId, regionId);
}

public Integer getRegionId() {
return regionId;
}
}