package mobile;

import java.sql.Connection;

import java.util.ArrayList;
import java.util.List;

import oracle.adfmf.framework.api.AdfmfJavaUtilities;
import mobile.CountryBO;
import database.ConnectionFactory;


import java.sql.ResultSet;
import java.sql.Statement;

import java.util.Arrays;
import java.util.Collections;

import oracle.adfmf.framework.api.AdfmfContainerUtilities;
import oracle.adfmf.framework.api.GenericTypeBeanSerializationHelper;
import oracle.adfmf.framework.exception.AdfInvocationException;
import oracle.adfmf.util.GenericType;
import oracle.adfmf.util.Utility;

public class CountryDC {

private static final String NOT_REACHABLE = "NotReachable"; // Indiates no network connectivity

public CountryDC() {
super();
}

// 1: Determine if the network is available by checking deviceScope.hardware.networkStatus property
public CountryBO[] getCountries() {
CountryBO[] countries = null;

String networkStatus =
(String)AdfmfJavaUtilities.evaluateELExpression("#{deviceScope.hardware.networkStatus}");

// 2: If the value of the deviceScope is NOT_REACHABLE, then call getCountriesFromDB else call getCountiresFromWS 
if (networkStatus.equals(NOT_REACHABLE)) {
countries = getCountriesFromDB();
} else {
countries = getCountriesFromWS();
}
return countries;

}

// 3: Use JDBC to get records from local database
private CountryBO[] getCountriesFromDB() {
Connection conn = null;
List returnValue = new ArrayList();

try {
conn = ConnectionFactory.getConnection();

Statement stmt = conn.createStatement();
ResultSet result = stmt.executeQuery("SELECT COUNTRY_ID, COUNTRY_NAME, REGION_ID FROM COUNTRIES;");
while (result.next()) {
CountryBO country = new CountryBO();
Utility.ApplicationLogger.severe("Country: " + result.getString("COUNTRY_ID"));
country.setId(result.getString("COUNTRY_ID"));
country.setCountry(result.getString("COUNTRY_NAME"));
country.setRegionId(new Integer(result.getInt("REGION_ID")));
returnValue.add(country);
}

} catch (Exception ex) {
Utility.ApplicationLogger.severe(ex.getMessage());
ex.printStackTrace();
throw new RuntimeException(ex);
}
Collections.sort(returnValue);
return (CountryBO[])returnValue.toArray(new CountryBO[returnValue.size()]);
}

// 4: Retrieve record from web service 
private CountryBO[] getCountriesFromWS() {
try {
GenericType genericReturnValue =
(GenericType)AdfmfJavaUtilities.invokeDataControlMethod("SM_WS", null, "findCountry", new ArrayList(),
new ArrayList(), new ArrayList());
CountryBO[] returnValue =
(CountryBO[])GenericTypeBeanSerializationHelper.fromGenericType(CountryBO[].class, genericReturnValue, "result");

Arrays.sort(returnValue);
return returnValue;

} catch (AdfInvocationException aie) {
if (AdfInvocationException.CATEGORY_WEBSERVICE.compareTo(aie.getErrorCategory()) == 0) {
throw new RuntimeException("Error with the server. Please try later", aie);
} else {
throw new RuntimeException(aie);

}
}
}
}
